[source] lantiq: split up dsl_notify.sh into separate notification handlers

LEDE Commits lede-commits at lists.infradead.org
Mon Aug 7 01:50:28 PDT 2017


mkresin pushed a commit to source.git, branch master:
https://git.lede-project.org/0481a2a2c5b85e82d3b7a55ee556c1a23dd1c135

commit 0481a2a2c5b85e82d3b7a55ee556c1a23dd1c135
Author: Martin Schiller <ms at dev.tdt.de>
AuthorDate: Thu Jun 29 06:49:49 2017 +0200

    lantiq: split up dsl_notify.sh into separate notification handlers
    
    This makes it possible to simply add additional notification handlers
    by putting new scripts in the /etc/hotplug.d/dsl directory.
    
    the following Environment Variables are used:
    
    (values marked with an * are only available when bonding support is
    compiled in)
    
    DSL_NOTIFICATION_TYPE with one of these values:
    - DSL_STATUS
    - DSL_INTERFACE_STATUS
    - DSL_DATARATE_STATUS_US
    - DSL_DATARATE_STATUS_DS
    
    DSL_LINE_NUMBER=<0|1> *
    
    If DSL_NOTIFICATION_TYPE == DSL_STATUS, these variables are set:
    
    - DSL_XTU_STATUS=<ADSL|VDSL>
    - DSL_TC_LAYER_STATUS=<ATM|EFM>
    - DSL_EFM_TC_CONFIG_US=<NORMAL|PRE_EMPTION>
    - DSL_EFM_TC_CONFIG_DS=<NORMAL>
    
    If DSL_NOTIFICATION_TYPE == DSL_INTERFACE_STATUS, these variables are
    set:
    
    - DSL_INTERFACE_STATUS=<DOWN|READY|HANDSHAKE|TRAINING|UP>
    - DSL_BONDING_STATUS=<INACTIVE|ACTIVE> *
    
    If DSL_NOTIFICATION_TYPE == DSL_DATARATE_STATUS_US, these variables are
    set:
    
    - DSL_DATARATE_US_BC0=<Upstream data rate in bit/s for Channel 0>
    - DSL_DATARATE_US_BC1=<Upstream data rate in bit/s for Channel 1> *
    
    If DSL_NOTIFICATION_TYPE == DSL_DATARATE_STATUS_DS, these variables are
    set:
    
    - DSL_DATARATE_DS_BC0=<Downstream data rate in bit/s for Channel 0>
    - DSL_DATARATE_DS_BC1=<Downstream data rate in bit/s for Channel 1> *
    
    Signed-off-by: Martin Schiller <ms at dev.tdt.de>
---
 .../lantiq/base-files/etc/hotplug.d/dsl/led_dsl.sh | 30 +++++++++
 .../lantiq/base-files/etc/hotplug.d/dsl/pppoa.sh   | 37 +++++++++++
 target/linux/lantiq/base-files/sbin/dsl_notify.sh  | 71 +---------------------
 3 files changed, 70 insertions(+), 68 deletions(-)

diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/dsl/led_dsl.sh b/target/linux/lantiq/base-files/etc/hotplug.d/dsl/led_dsl.sh
new file mode 100755
index 0000000..0bf749c
--- /dev/null
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/dsl/led_dsl.sh
@@ -0,0 +1,30 @@
+#!/bin/sh
+
+[ "$DSL_NOTIFICATION_TYPE" = "DSL_INTERFACE_STATUS" ] || exit 0
+
+. /lib/functions.sh
+. /lib/functions/leds.sh
+
+led_dsl_up() {
+	case "$(config_get led_dsl trigger)" in
+	"netdev")
+		led_set_attr $1 "trigger" "netdev"
+		led_set_attr $1 "device_name" "$(config_get led_dsl dev)"
+		led_set_attr $1 "mode" "$(config_get led_dsl mode)"
+		;;
+	*)
+		led_on $1
+		;;
+	esac
+}
+
+config_load system
+config_get led led_dsl sysfs
+if [ -n "$led" ]; then
+	case "$DSL_INTERFACE_STATUS" in
+	  "HANDSHAKE")  led_timer $led 500 500;;
+	  "TRAINING")   led_timer $led 200 200;;
+	  "UP")		led_dsl_up $led;;
+	  *)		led_off $led
+	esac
+fi
diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/dsl/pppoa.sh b/target/linux/lantiq/base-files/etc/hotplug.d/dsl/pppoa.sh
new file mode 100755
index 0000000..b9a3313
--- /dev/null
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/dsl/pppoa.sh
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+[ "$DSL_NOTIFICATION_TYPE" = "DSL_INTERFACE_STATUS" ] || exit 0
+
+. /usr/share/libubox/jshn.sh
+. /lib/functions.sh
+
+include /lib/network
+scan_interfaces
+
+interfaces=`ubus list network.interface.\* | cut -d"." -f3`
+for ifc in $interfaces; do
+
+	json_load "$(ifstatus $ifc)"
+
+	json_get_var proto proto
+	if [ "$proto" != "pppoa" ]; then
+		continue
+	fi
+
+	json_get_var up up
+	config_get_bool auto "$ifc" auto 1
+	if [ "$DSL_INTERFACE_STATUS" = "UP" ]; then
+		if [ "$up" != 1 ] && [ "$auto" = 1 ]; then
+			( sleep 1; ifup "$ifc" ) &
+		fi
+	else
+		if [ "$up" = 1 ] && [ "$auto" = 1 ]; then
+			( sleep 1; ifdown "$ifc" ) &
+		else
+			json_get_var autostart autostart
+			if [ "$up" != 1 ] && [ "$autostart" = 1 ]; then
+				( sleep 1; ifdown "$ifc" ) &
+			fi
+		fi
+	fi
+done
diff --git a/target/linux/lantiq/base-files/sbin/dsl_notify.sh b/target/linux/lantiq/base-files/sbin/dsl_notify.sh
index 4804e2a..d615db5 100755
--- a/target/linux/lantiq/base-files/sbin/dsl_notify.sh
+++ b/target/linux/lantiq/base-files/sbin/dsl_notify.sh
@@ -1,71 +1,6 @@
 #!/bin/sh
 #
-# This script is called by dsl_cpe_control whenever there is a DSL event,
-# we only actually care about the DSL_INTERFACE_STATUS events as these
-# tell us the line has either come up or gone down.
-#
-# The rest of the code is basically the same at the atm hotplug code
-#
-
-[ "$DSL_NOTIFICATION_TYPE" = "DSL_INTERFACE_STATUS" ] || exit 0
-
-. /usr/share/libubox/jshn.sh
-. /lib/functions.sh
-. /lib/functions/leds.sh
-
-led_dsl_up() {
-	case "$(config_get led_dsl trigger)" in
-	"netdev")
-		led_set_attr $1 "trigger" "netdev"
-		led_set_attr $1 "device_name" "$(config_get led_dsl dev)"
-		led_set_attr $1 "mode" "$(config_get led_dsl mode)"
-		;;
-	*)
-		led_on $1
-		;;
-	esac
-}
-
-include /lib/network
-scan_interfaces
-
-config_load system
-config_get led led_dsl sysfs
-if [ -n "$led" ]; then
-	case "$DSL_INTERFACE_STATUS" in
-	  "HANDSHAKE")  led_timer $led 500 500;;
-	  "TRAINING")   led_timer $led 200 200;;
-	  "UP")		led_dsl_up $led;;
-	  *)		led_off $led
-	esac
-fi
-
-interfaces=`ubus list network.interface.\* | cut -d"." -f3`
-for ifc in $interfaces; do
-
-	json_load "$(ifstatus $ifc)"
-
-	json_get_var proto proto
-	if [ "$proto" != "pppoa" ]; then
-		continue
-	fi
-
-	json_get_var up up
-	config_get_bool auto "$ifc" auto 1
-	if [ "$DSL_INTERFACE_STATUS" = "UP" ]; then
-		if [ "$up" != 1 ] && [ "$auto" = 1 ]; then
-			( sleep 1; ifup "$ifc" ) &
-		fi
-	else
-		if [ "$up" = 1 ] && [ "$auto" = 1 ]; then
-			( sleep 1; ifdown "$ifc" ) &
-		else
-			json_get_var autostart autostart
-			if [ "$up" != 1 ] && [ "$autostart" = 1 ]; then
-				( sleep 1; ifdown "$ifc" ) &
-			fi
-		fi
-	fi
-done
-
+# This script is called by dsl_cpe_control whenever there is a DSL event
+# and calls any available hotplug script(s) in /etc/hotplug.d/dsl.
 
+exec /sbin/hotplug-call dsl



More information about the lede-commits mailing list